/*!
 * JSSDK-DtDream v0.0.2
 * (c) 2014-2017 DtDream
 * Released under the MIT License.
 */
(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
	typeof define === 'function' && define.amd ? define(factory) :
	(global.dd = factory());
}(this, (function () { 'use strict';

var notification = [
    {
        namespace: 'device.notification.alert',
        name: '弹窗alert',
        defaultParams: {
            title: '',
            buttonName: '确定'
        }
    }, {
        namespace: 'device.notification.confirm',
        name: '弹窗confirm',
        defaultParams: {
            title: '',
            buttonLabels: ['确定', '取消']
        }
    }, {
        namespace: 'device.notification.prompt',
        name: '弹窗prompt',
        defaultParams: {
            title: '',
            buttonLabels: ['确定', '取消']
        }
    }, {
        namespace: 'device.notification.vibrate',
        name: '震动',
        defaultParams: {
            duration: 300
        }
    }, {
        namespace: 'device.notification.toast',
        name: 'Toast',
        defaultParams: {
            text: 'toast',
            duration: 2
        }
    }, {
        namespace: 'device.notification.showPreloader',
        name: '显示浮层',
        defaultParams: {
            text: '加载中...',
            showIcon: true
        }
    }, {
        namespace: 'device.notification.hidePreloader',
        name: '隐藏浮层'
    }, {
        namespace: 'device.notification.actionSheet',
        name: 'ActionSheet控件',
        defaultParams: {
            cancelButton: '取消'
        }
    }, {
        namespace: 'device.notification.selectImg',
        name: '图片选择'
    }, {
        namespace: 'device.notification.chooseImage',
        name: '图片上传'
    }
];

var audio = [
    {
        namespace: 'device.audio.startRecord',
        name: '开始录制音频'
    },
    {
        namespace: 'device.audio.stopRecord',
        name: '停止录制音频'
    },
    {
        namespace: 'device.audio.onRecordEnd',
        name: '监听录音自动停止'
    },
    {
        namespace: 'device.audio.download',
        name: '下载音频'
    },
    {
        namespace: 'device.audio.play',
        name: '播放音频'
    },
    {
        namespace: 'device.audio.pause',
        name: '暂停播放音频'
    },
    {
        namespace: 'device.audio.onPlayEnd',
        name: '监听播放音频停止的事件接口'
    },
    {
        namespace: 'device.audio.resume',
        name: '暂停之后继续播放音频'
    },
    {
        namespace: 'device.audio.stop',
        name: '停止播放音频'
    }
];

var win$1 = window;
var device = [
    {
        namespace: 'device.location.get',
        name: '定位'
    },
    {
        namespace: 'device.launcher.checkInstalledApps',
        name: '检测应用是否安装'
    },
    {
        namespace: 'device.launcher.launchApp',
        name: '启动第三方app'
    },
    {
        namespace: 'device.base.getUUID',
        name: '获取通用唯一识别码（卸载重新安装会改变）'
    },
    {
        namespace: 'device.connection.getNetworkType',
        name: '获取当前网络类型'
    },
    {
        namespace: 'device.accelerometer.watchShake',
        name: '启动摇一摇',
        defaultParams: { watch: true },
        paramsCallback: function (params) {
            win$1.dd && win$1.dd.ios && (params.sensitivity = 3.2);
        }
    },
    {
        namespace: 'device.accelerometer.clearShake',
        name: '停止摇一摇',
        defaultParams: {},
        msg: '公交'
    },
    {
        namespace: 'device.screen.highlightSet',
        name: '调整屏幕亮度',
        defaultParams: {
            value: '0.5'
        },
        msg: '公交'
    },
    {
        namespace: 'device.screen.highlightReset',
        name: '重置屏幕亮度',
        msg: '公交'
    }
];
device = [].concat(device, notification, audio);
var device$1 = device;

var util = [
    {
        namespace: 'biz.util.selectLocalCity',
        name: '获取当前所在城市的信息',
        defaultParams: { cityId: '419900', cityName: '省本级' }
    },
    {
        namespace: 'biz.util.scan',
        name: '扫码(支持二维码和条形码)',
        defaultParams: { type: 'qrCode' }
    },
    {
        namespace: 'biz.util.share',
        name: '分享'
    },
    {
        namespace: 'biz.util.pay',
        name: '支付'
    },
    {
        namespace: 'biz.util.request',
        name: '请求代理',
        defaultParams: {
            method: 'GET'
        }
    },
    {
        namespace: 'biz.util.openLink',
        name: '新开页面'
    }
];

var navigation = [
    {
        namespace: 'biz.navigation.setTitle',
        name: '设置导航栏标题'
    },
    {
        namespace: 'biz.navigation.show',
        name: '显示导航栏'
    },
    {
        namespace: 'biz.navigation.hide',
        name: '隐藏导航栏'
    },
    {
        namespace: 'biz.navigation.close',
        name: '关闭webview'
    },
    {
        namespace: 'biz.navigation.setSegmentedTitle',
        name: '设置切换分段控制器'
    },
    {
        namespace: 'biz.navigation.setLeft',
        name: '设置导航左侧按钮',
        defaultParams: {
            show: true,
            control: false,
            showIcon: true,
            text: ''
        }
    },
    {
        namespace: 'biz.navigation.setRightBtn',
        name: '设置导航右侧按钮文字',
        defaultParams: {
            show: true,
            control: false,
            text: ''
        }
    },
    {
        namespace: 'biz.navigation.setRight',
        name: '设置导航右侧按钮文字',
        message: '公交',
        defaultParams: {
            show: true,
            control: false,
            text: ''
        }
    },
    {
        namespace: 'biz.navigation.setMenu',
        name: '设置导航左侧按钮',
        defaultParams: {
            backgroundColor: '#FF000000'
        }
    }
];

var biz = [
    {
        namespace: 'biz.telephone.call',
        name: '打电话'
    },
    {
        namespace: 'biz.telephone.sms',
        name: '发短信'
    },
    {
        namespace: 'biz.user.checkLogin',
        name: '检查是否登录'
    },
    {
        namespace: 'biz.map.getLocation',
        name: '获取当前地理位置',
        msg: '公交'
    },
    {
        namespace: 'biz.user.get',
        name: '获取用户token',
        msg: '公交'
    },
    {
        namespace: 'biz.controller.push',
        name: '跳转指定控制器',
        msg: '公交'
    },
    {
        namespace: 'biz.map.getLocation',
        name: '获取App当前经纬度',
        msg: '公交'
    },
    {
        namespace: 'biz.user.get',
        name: '通用JSAPI接口获取用户信息',
        msg: '公交'
    },
    {
        namespace: 'biz.map.navigation',
        name: '地图导航',
        msg: '公交'
    },
    {
        namespace: 'biz.order.alipay',
        name: '获取阿里支付订单信息',
        msg: '公交'
    },
    {
            namespace: 'biz.order.wxMini',
            name: '跳转微信小程序',
            msg: '公交'
        },
];
var biz$1 = [].concat(biz, util, navigation);

var util$2 = [
    {
        namespace: 'util.localStorage.getItem',
        name: '本地存储, 获取'
    },
    {
        namespace: 'util.localStorage.setItem',
        name: '本地存储, 设置'
    },
    {
        namespace: 'util.localStorage.removeItem',
        name: '本地存储, 删除'
    }
];

var methods = {
    device: device$1,
    biz: biz$1,
    util: util$2,
    ui: [
        {
            namespace: 'ui.input.plain',
            name: '输入框（单行）'
        },
        {
            namespace: 'ui.webViewBounce.enable',
            name: '启用webview下拉弹性效果'
        },
        {
            namespace: 'ui.webViewBounce.disable',
            name: '禁用webview下拉弹性效果'
        },
        {
            namespace: 'ui.pullToRefresh.enable',
            name: '启用下拉刷新'
        },
        {
            namespace: 'ui.pullToRefresh.stop',
            name: '停止下拉刷新'
        },
        {
            namespace: 'ui.pullToRefresh.disable',
            name: '禁用下拉刷新'
        }
    ]
};

/**
 * debug
 * @param {string} message - debug message
 */
function debug(message) {
    var win = window;
    var debug = !!win.dd && !!win.dd.config && !!win.dd.config.debug;
    if (debug) {
        var log = window.console.log;
        log.call(window.console, message);
    }
}

/**
 * 将命名空间的string转化为嵌套对象, 并将方法执行体挂载最后
 * @param {object} dd - dd对象树
 * @param {string} namespace - 命名空间: 'device.notification.alert'
 * @param {function} methodHandler - 方法的执行函数: alert的执行方法
 *
 * @description
 * 'device.notification.alert' -> dd:{device:{notification:{alert:methodHandler}}}
 */
function namespaceToObjectTree(dd, namespace, methodHandler) {
    var _dd = dd;
    var namespaceArr = namespace.split('.'); // ["device", "notification", "alert"]
    var i, length;
    for (i = 0, length = namespaceArr.length; i < length; i++) {
        if (i === length - 1) {
            // 最后一个时 alert, 挂载函数方法
            _dd[namespaceArr[i]] = methodHandler;
        }
        if (!_dd[namespaceArr[i]]) {
            _dd[namespaceArr[i]] = {};
        }
        _dd = _dd[namespaceArr[i]];
    }
    return _dd;
}

function extend(dist, source) {
    if (source) {
        for (var key in source) {
            dist[key] = source[key];
        }
    }
    return dist;
}

var win$2 = window;
/**
 * bridge方法的执行器
 *
 * @param {string} namespace - 命名空间, 比如: 'device.notification.alert'
 * @param {object} extraParams - 额外参数
 * @param {object} namespaceInfo - 当前命名空间的参数信息, 比如: 'device.notification.alert'
 * @param {object} namespaceInfo.namespace - 命名空间, 比如: 'device.notification.alert'
 * @param {object} namespaceInfo.name - 命名空间, 比如: '弹窗alert'
 * @param {object} namespaceInfo.ios - ios版本, 比如: '2.4.0'
 * @param {object} namespaceInfo.android - 安卓版本, 比如: '2.4.0'
 * @param {object} namespaceInfo.defaultParams - 默认参数
 */
function webViewJavascriptBridgeExecutor(namespace, extraParams, namespaceInfo) {
    if ('undefined' === typeof win$2.WebViewJavascriptBridge) {
        debug('Variable [win.WebViewJavascriptBridge] does not exist!');
        return false;
    }
    var params = {}; // 当前方法的参数
    params = extend(params, namespaceInfo && namespaceInfo.defaultParams);
    extend(params, extraParams);
    // 参数过滤
    namespaceInfo && namespaceInfo.paramsCallback && namespaceInfo.paramsCallback(params);
    var onSuccess = function (result) {
        debug("Default success callback " + namespace + " " + result);
    };
    var onFail = function (result) {
        debug("Default failure callback " + namespace + " " + result);
    };
    var onCancel = function (result) {
        debug("Default cancel callback " + namespace + " " + result);
    };
    if (params.onSuccess) {
        onSuccess = params.onSuccess;
        delete params.onSuccess;
    }
    if (params.onFail) {
        onFail = params.onFail;
        delete params.onFail;
    }
    if (params.onCancel) {
        onCancel = params.onCancel;
        delete params.onCancel;
    }
    /**
     * 响应结果兜底
     * @param {string} data - 响应对象的string, 需要自己JSON.parse
     * @param {object} data.errorCode - errorCode
     * @param {object} data.errorMessage - errorMessage
     * @param {object} data.result - result
     */
    var responseHandler = function (data) {
        console.info("App\u8FD4\u56DE\u7ED3\u679C: " + data);
        console.info("App\u8FD4\u56DE\u7ED3\u679C: " + JSON.stringify(data));
        try {
            var response = JSON.parse(data);
            var errorCode = response.errorCode;
            var errorMessage = response.errorMessage;
            var result = response.result;
            if ('0' === errorCode) {
                onSuccess && onSuccess.call(null, result);
            }
            else if ('-1' === errorCode) {
                onCancel && onCancel.call(null, result);
            }
            else {
                onFail && onFail.call(null, errorMessage, errorCode);
            }
        }
        catch (err) {
            console.error('JSON.parse Error in responseHandler from app retruns');
            onFail && onFail.call(null, 'ResponseHandler: JSON.parse Error!');
        }
    };
    var watch = params.watch;
    var handleData = {
        handlerName: namespace,
        params: params
    };
    debug('开始执行 webViewJavascriptBridgeExecutor');
    debug("\u4F20\u5165\u6570\u636E: " + JSON.stringify(handleData));
    if (watch) {
        win$2.WebViewJavascriptBridge && win$2.WebViewJavascriptBridge.registerHandler(namespace, function (data, callback) {
            responseHandler(data);
            callback && callback({
                errorCode: '0',
                errorMessage: '成功'
            });
        });
        win$2.WebViewJavascriptBridge && win$2.WebViewJavascriptBridge.callHandler('dd.native.call', handleData, responseHandler);
    }
    else {
        win$2.WebViewJavascriptBridge && win$2.WebViewJavascriptBridge.callHandler('dd.native.call', handleData, responseHandler);
    }
}

/**
 * methodExecutor
 * @description
 * 如果当前环境中有 promise 则返回promise结果
 * @param {string} namespace - 命名空间: 'device.notification.alert'
 * @param {object} params - 外部参数
 * @param {object} namespaceInfo - 命名空间对象
 */
function methodExecutor(namespace, params, namespaceInfo) {
    webViewJavascriptBridgeExecutor(namespace, params, namespaceInfo);
}

// Import here Polyfills if needed. Recommended core-js (npm i -D core-js)
// import "core-js/fn/array.find"
// ...
var win = window;
var userAgent = win.navigator.userAgent;
var sdkVersion = '0.0.2';
var isInit = false;
var versions = userAgent.match(/dtdream\(\w+\/([a-zA-Z0-9.-]+)\)/);
var version = versions ? versions[1] : '';
var dd = {
    ios: /iPhone|iPad|iPod/i.test(userAgent),
    android: /Android/i.test(userAgent),
    dtdream: /dtdream/i.test(userAgent),
    version: version,
    type: function (e) {
        return Object.prototype.toString.call(e).match(/^\[object\s(.*)\]$/)[1];
    },
    sdk_version: sdkVersion,
    methods: methods,
    config: {
        debug: true
    },
    error: function (callbacks) {
        if (callbacks === void 0) { callbacks = noop; }
        debug('error');
        
    },
    ready: function (callbacks) {
        // Ensure errorCallback is configured correctly
        win.setTimeout(function () {
            if (!dd.dtdream) {
                isInit = false;
                return debug('Please open this page in DtDream App!');
            }
            var execute = function (JavascriptBridge) {
                if (!JavascriptBridge)
                    return debug('bridge init failure!');
                callbacks && callbacks.apply(null, JavascriptBridge);
                isInit = true;
            };
            if (win.WebViewJavascriptBridge) {
                execute(win.WebViewJavascriptBridge);
            }
            else {
                document.addEventListener('WebViewJavascriptBridgeReady', function () {
                    if (!isInit) {
                        execute(win.WebViewJavascriptBridge);
                    }
                }, false);
                setupWebViewJavascriptBridge(function () {
                    if ('undefined' === typeof win.WebViewJavascriptBridge) {
                        return debug('Please open this page in DtDream App!!');
                    }
                    if (!isInit) {
                        execute(win.WebViewJavascriptBridge);
                    }
                });
            }
        }, 0);
    },
    compareVersion: function (leftVersion, rightVersion, include) {
        if ('string' !== typeof leftVersion || 'string' !== typeof rightVersion) {
            return false;
        }
        var leftVersionArr = leftVersion.split('.'); // 3.1.0
        var rightVersionArr = rightVersion.split('.'); // 3.5.0
        var leftVer = '';
        var rightVer = '';
        for (; leftVer === rightVer && rightVersionArr.length > 0;) {
            leftVer = leftVersionArr.shift() || '';
            rightVer = rightVersionArr.shift() || '';
        }
        if (include) {
            return parseInt(rightVer, 10) >= parseInt(leftVer, 10);
        }
        else {
            return parseInt(rightVer, 10) > parseInt(leftVer, 10);
        }
    }
};
// The methods in methods are generated to access objects
if (dd.methods) {
    for (var classify in dd.methods) {
        if (classify && dd.methods[classify]) {
            dd.methods[classify].forEach(function (namespaceInfo) {
                namespaceToObjectTree(dd, namespaceInfo.namespace, function (extraParams) {
                    return methodExecutor(namespaceInfo.namespace, extraParams, namespaceInfo);
                });
            });
        }
    }
}
// You need to manually notify the app to mount WebViewJavascriptBridge objects
setupWebViewJavascriptBridge();
// Manual to mount WebViewJavascriptBridge
function setupWebViewJavascriptBridge(callback) {
    if (callback === void 0) { callback = noop; }
    win.WVJBCallbacks = [noop];
    var WVJBIframe = document.createElement('iframe');
    WVJBIframe.style.display = 'none';
    WVJBIframe.src = 'ddjsscheme://__bridge_loaded__';
    document.documentElement.appendChild(WVJBIframe);
    win.setTimeout(function () {
        document.documentElement.removeChild(WVJBIframe);
        callback && callback(win.WebViewJavascriptBridge);
    }, 0);
}
function noop() {
    debug('noop');
}
// Global, you have to put it here
win.dd = dd;

return dd;

})));
//# sourceMappingURL=jssdk.umd.js.map
